#ifndef PARSEBUF
#define PARSEBUF

#include<stdio.h>
#include<string.h>
#include<malloc.h>

#ifdef PARSEBUF_GLOBAL
int thisLineNum = 1;
#else
extern int thisLineNum;
#endif

typedef enum {kBank, 
              kCh, 
			  kFreq, 
			  kDup, 
			  kOffset, 
			  kTsql, 
			  kTone, 
			  kMode, 
			  kStep, 
			  kSkip,
			  kEOL,
			  kInvalidToken } tokentype;

struct keyword {char * text; tokentype token;};



class CToken {
public:
	CToken() {data = NULL;}
	~CToken() {if(data) free(data);}
	tokentype type;
	char * data;
};

const int kMaxLineLength = 256;

class CParseBuffer {
public:
	CParseBuffer();
	setData(const char *inputLine);
	setDataFromFile(FILE *fp);
	void getNextToken(CToken * tok);
private:
	char buffer[kMaxLineLength+3];
	unsigned int buffpos;
};

#endif // PARSEBUF