#include "r2serial.h"
#include "assert.h"
#include <stdio.h>
#include <windows.h>



HANDLE hComm;

BOOL UpdateConnection();


int openR2Port (const char * portName){

	hComm = CreateFile( portName, GENERIC_READ | GENERIC_WRITE,
		0,
		0,
		OPEN_EXISTING,
		0,
		0);

	if(hComm == INVALID_HANDLE_VALUE) {
		assert( 0 && "invalid handle value");
		return 1;
	}

	UpdateConnection();

	SetupComm(hComm, 2048, 1);

	// raise DTR

	if (!EscapeCommFunction(hComm, SETDTR)) {
		assert( 0 && "can't set DTR");
		return 1;
	}
	
	return 0;
}

//#define HACKING

int getR2SerialByte(unsigned char * byte) {
	char buff[2];
	DWORD numRead;

	if (!ReadFile(hComm, buff, 1, &numRead, 0))
		return 1;

	if (numRead != 1)
		return 1;

	*byte = buff[0];

#ifdef HACKING 
	// pretend WE're an r2, and send this
	// byte back to the computer at the other end
	putR2SerialByte(*byte);
#endif //HACKING

	return 0;
}

int putR2SerialByte(unsigned char byte) {
	char buff[2];
	buff[0] = byte;
	buff[1] = '\0';
	DWORD numWritten;

	if (!WriteFile(hComm, buff, 1, &numWritten, 0))
		return 1;

	if(numWritten != 1)
		return 1;

#ifndef HACKING
	// read the byte we just got
	unsigned char echo;
	getR2SerialByte(&echo);
	assert(echo == byte);
#endif
	return 0;
}



int closeR2Port (){

	CloseHandle(hComm);

	return 0;
}


BOOL UpdateConnection()
{
    DCB dcb;
	FillMemory(&dcb, sizeof(dcb), 0);
    
    dcb.DCBlength = sizeof(dcb);

	if (!GetCommState(hComm, &dcb))
		assert(0 && "GetCommState");

	dcb.BaudRate = 9600;
	dcb.fBinary = TRUE;
	dcb.fParity = FALSE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fTXContinueOnXoff = TRUE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;



    //
    // set new state
    //
    if (!SetCommState(hComm, &dcb))
	    assert(0 &&"SetCommState");


    return TRUE;
}
